function code()
	if (updatecode == 1) then
		features = {}
		featureindex = {}
		firstwords = {}
		local existing = {}
	
		if (#codeunits > 0) then
			for iid,unitid in ipairs(codeunits) do
				local unit = mmf.newObject(unitid)
				local x,y = unit.values[XPOS],unit.values[YPOS]
				local unittype = unit.values[TYPE]
				local name = unit.strings[NAME]
				local ox,oy = 0,0
				
				unit.direction = 0
				
				for i=1,2 do
					local drs = dirs[i+2]
					local start = false
					ox = drs[1]
					oy = drs[2]
					local steps = 0
					local limit = 0
					local valid = 0
					
					while (start == false) do
						local hm = codecheck(unitid,ox * steps,oy * steps)
						steps = steps + 1
						
						if (hm > 0) then
							local tile = mmf.newObject(hm)

							if (tile.values[TYPE] == 1) then
								limit = limit - 1
							else
								limit = limit + 1
							end
							
							if (limit == 1) then
								valid = hm
							end
							
							if (limit < 0) or (limit > 1) then
								start = true
							end
						else
							start = true
						end
					end
					
					if (valid > 0) then
						local vid = tostring(i) .. "_" .. tostring(valid)
						
						if (existing[vid] == nil) then
							table.insert(firstwords, {valid, i})
							existing[vid] = 1
							
							local validunit = mmf.newObject(valid)
						end
					end
				end
			end
			
			docode()
			updatecode = 0
		end
	end
end

function docode()
	if (#firstwords > 0) then
		for k,unitdata in ipairs(firstwords) do
			local unit = mmf.newObject(unitdata[1])
			local x,y = unit.values[XPOS],unit.values[YPOS]
			local ox,oy = 0,0
			local name = unit.strings[NAME]
			--print("first word: " .. name .. ", dir: " .. tostring(unitdata[2]))
			
			local dir = unitdata[2]
			local drs = dirs[dir]
			ox = drs[1]
			oy = drs[2]
			
			local limit = 0
			local steps = 0
			local done = false
			local sentence = {}
			
			while (done == false) do
				local hm = codecheck(unitdata[1],ox * steps,oy * steps)
				steps = steps + 1
				
				if (hm > 0) then
					local tile = mmf.newObject(hm)
					local tilename = tile.strings[NAME]
					local tiletype = tile.values[TYPE]
					
					if (tiletype == 1) then
						limit = limit - 1
					else
						limit = limit + 1
					end
					
					if (limit >= 0) and (limit <= 1) then
						table.insert(sentence, {tilename, tiletype, hm, tiletype})
					else
						done = true
					end
				else
					local latest = sentence[#sentence]
					if (latest[2] == 1) then
						table.remove(sentence, #sentence)
					end
					done = true
				end
			end
			
			if (#sentence > 2) then
				local phase = 0
				local absphase = 0
				limit = 0
				local groups = {}
				local visuals = {}
				local ops = {}
				local groupid = 1
				local visualid = 1
				groups[groupid] = {}
				visuals[visualid] = {}
				
				for a,b in ipairs(sentence) do
					if (b[2] ~= 1) then
						local thisgroup = groups[groupid]
						local thisvis = visuals[visualid]
						table.insert(thisgroup, b[1])
						table.insert(thisvis, {b[3], b[4]})
						limit = limit + 1
					end
					
					if (b[2] == 1) then
						if (b[1] ~= "and") then
							table.insert(ops, b[1])
							
							groupid = groupid + 1
							groups[groupid] = {}
						end
						limit = limit - 1
						
						local thisvis = visuals[visualid]
						table.insert(thisvis, {b[3], b[4]})
						visualid = visualid + 1
						visuals[visualid] = {}
					end
					
					if (b[1] == "is") and (phase ~= 1) then
						phase = 1
						
						if (absphase <= 1) then
							absphase = absphase + 1
						else
							absphase = absphase + 2
						end
					end
					
					if (b[1] == "in") and (phase ~= 2) then
						phase = 2
						absphase = absphase + 1
					end
					
					if (b[1] == "on") and (phase ~= 3) then
						phase = 3
						absphase = absphase + 1
					end
					
					if (absphase > 3) then
						local previous = sentence[a-1]
						table.insert(firstwords, {previous[3], dir})
						table.remove(ops, #ops)
						table.insert(ops, "end")
						break
					end 
					
					if (limit < 0) or (limit > 1) then
						phase = 99
						limit = 99
						
						if (limit < 0) then
							table.remove(ops, #ops)
							table.remove(visuals, #visuals)
						elseif (limit > 1) then
							local thisgroup = groups[groupid]
							local thisvis = visuals[visualid]
							table.remove(thisgroup, #thisgroup)
							table.remove(thisvis, #thisvis)
							
							if (#thisgroup == 0) then
								table.remove(groups, groupid)
							end
							
							if (#thisvis == 0) then
								table.remove(visuals, visualid)
							end
						end
						
						table.insert(ops, "end")
						break
					end
				end
				
				if (#groups > 0) then
					for a,group in ipairs(groups) do
						local style = ops[a]
						local prevstyle = ""
						local nextstyle = ""
						
						if (ops[a-1] ~= nil) then
							prevstyle = ops[a-1]
						end
						
						if (ops[a+1] ~= nil) then
							nextstyle = ops[a+1]
						end
						
						if (style ~= "on") and (prevstyle ~= "on") and (nextstyle ~= "on") then
							for c,d in ipairs(group) do
								local nextgroup = groups[a+1]
								
								if (nextgroup ~= nil) then
									for e,f in ipairs(nextgroup) do
										addoption({d,style,{f}})
									end
								end
							end
						elseif (style == "on") then
							local nextgroup = groups[a+1]
							local nextgroup2 = groups[a+2]
							local prevgroup = groups[a-1]
							local style2 = ops[a+1]
							local style3 = ops[a-1]

							if (nextgroup ~= nil) and (nextgroup2 ~= nil) and (style2 ~= nil) then
								for c,d in ipairs(group) do
									for e,f in ipairs(nextgroup2) do
										addoption({d,"on",nextgroup,style2,f})
									end
								end
							end
							
							if (nextgroup ~= nil) and (prevgroup ~= nil) and (style3 ~= nil) then
								for c,d in ipairs(prevgroup) do
									for e,f in ipairs(group) do
										addoption({d,"on",nextgroup,style3,f})
									end
								end
							end
						end
					end
					
					-- TÄMÄ ON KESKEN! Vaatii miettimistä - miten saadaan tekstin efektistä yhtä hyvin toimiva kuin lauseenlöytämisestä (ilman liiallista raskautta)?
					local vvalid = false
					
					for d,c in ipairs(visuals) do
						for e,f in ipairs(c) do
							local this = mmf.newObject(f[1])
							
							if (this.values[TYPE] == 0) and (d == 1) then
								vvalid = true
							end
							
							if vvalid then
								if (this.values[TYPE] ~= 2) or ((this.values[TYPE] == 2) and (d > 1)) then
									this.direction = 1
								end
							end
						end
					end
				end
			end
		end
	end
end

function codecheck(unitid,ox,oy)
	local unit = mmf.newObject(unitid)
	local x,y = unit.values[XPOS],unit.values[YPOS]
	local result = 0
	for i,b in ipairs(codeunits) do
		local v = mmf.newObject(b)
		local ux,uy = v.values[XPOS],v.values[YPOS]
		
		if (ux == x + ox) and (uy == y + oy) then
			result = b
		end
	end
	
	return result
end

function addoption(option)
	if (#option == 3) or (#option == 5) then
		table.insert(features, option)
		local b = option[1]
		local d = option[#option]
		local o3 = option[3]
		
		if (#option == 3) then
			d = option[#option][1]
		end
	
		if (featureindex[d] == nil) then
			featureindex[d] = {}
		end
		
		if (featureindex[b] == nil) then
			featureindex[b] = {}
		end
		
		table.insert(featureindex[d], option)
		
		if (d ~= b) then
			table.insert(featureindex[b], option)
		end
		
		if (#option == 5) then
			local onall = false
					
			for e,f in ipairs(option[3]) do
				if (f == "all") then
					onall = true
				end
			end
			
			if onall then
				local newon = {}
						
				for e,f in ipairs(materials) do
					if (f ~= "empty") and (f ~= "all") then
						table.insert(newon, f)
					end
				end
				
				o3 = newon
				
				if (b ~= "all") then
					addoption({b,option[2],o3,option[4],d})
				end
			end
		end
		
		if (d == "all") then
			if (#option == 3) then
				if (option[2] ~= "is") then 
					for i,v in ipairs(materials) do
						if (v ~= "empty") and (v ~= "all") then
							addoption({b,option[2],{v}})
						end
					end
				end
			elseif (#option == 5) then
				if (option[4] ~= "is") then 
					for i,v in ipairs(materials) do
						if (v ~= "empty") and (v ~= "all") then
							addoption({b,option[2],o3,option[4],v})
						end
					end
				end
			end
		end

		if (b == "all") then
			if (#option == 3) then
				for i,v in ipairs(materials) do
					if (v ~= "empty") and (v ~= "all") then
						addoption({v,option[2],{d}})
					end
				end
			elseif (#option == 5) then
				for i,v in ipairs(materials) do
					if (v ~= "empty") and (v ~= "all") then
						addoption({v,option[2],o3,option[4],d})
					end
				end
			end
		end
	end
end